#include "magic.hh"
#include <stdio.h>
#include <string.h>

const char ascii[]=
"abcdefghijklmnopqrstuvwxyz" \
"ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
"0123456789!@#$%^&*(){}[]\"'" \
"~=+-,./?<>|\t\n\r ";

magicType fileType(FILE* f)
return r
{
  r=typeUnknown;
  unsigned char buf[4];
  if (fread(buf, 1, 4, f)==4) {
    if ((buf[0]==0x1f) && (buf[1]==0x8b)) {
      r=typeGzip;
    } else
    if (buf[0]=='%' && buf[1]=='!' && buf[2]=='P' && buf[3]=='S') {
      r=typePostScript;
    } else 
    if (buf[0]=='.' && (buf[3]==32 || buf[3]==9 || buf[3]==10)) {
      r=typeTroff;
    } else
    if ((index(ascii, buf[0]) &&
      index(ascii, buf[1]) &&
      index(ascii, buf[2]) &&
      index(ascii, buf[3]))) {
      r=typeAscii;
    }
  }
}
