#ifndef MM
#define MM
#include <new.h>

extern char* data;
extern int* heapPointer;

bool initMM(char* fname, int maxSize, bool onMemory=false);
void doneMM();
void* mmAlloc(int bytes);
int dataStored();

template <class a> 
class mmBlock {
 public:
  int ptr;
  mmBlock() {  
    ptr=-1;
  }
  mmBlock(int i) {
    if (!i) {
      ptr=-1;
    } else {
      ptr=i;
    }
  }
  mmBlock(a* i) {
    if (!i) {
      ptr=-1;
    } else {
      ptr=(int)((char*)i-data);
    }
  }
  mmBlock(a& i) {
    ptr=(int)((char*)&i-data);
  }
  inline mmBlock<a>& operator =(void* p) {
    if (!p) {
      ptr=-1; 
    } else {
      ptr=(char*) p-data;
    }
    return *this;
  }
  inline operator bool() {
    return ptr!=-1;
  }
  inline operator a*() {
    if (ptr==-1) {
      return 0;
    } else {
      return (a*)(data+ptr);
    }
  }
  inline a* operator ->() {
    return (a*)(data+ptr);
  }
  inline operator int() {
    return (int)((char*)this-data);
  }
};

class mmStorage {
 public:
  inline void* operator new(size_t bytes) {
    return (void*) mmAlloc(bytes);
  }
};
#endif
